# Deprecated due to issues with RF in the enclosure
from adafruit_ble import BLERadio
from adafruit_ble.advertising.standard import ProvideServicesAdvertisement
from adafruit_ble.services.nordic import UARTService
import sys
import datetime

ble = BLERadio()

uart_connection = None
uart_service = None

stop = False
output = ""
runningOperation = ""
cycle = 0
currentCycle = 0
startTime = 0
endTime = 0
overallStart = 0
overallStop = 0
cycleStart = 0
cycleStop = 0

while True:
    if not uart_connection:
        print("Trying to connect...")
        for adv in ble.start_scan(ProvideServicesAdvertisement): # , interval=0.1, window=0.1, extended=True, buffer_size=4096):
            # print(adv)
            if UARTService in adv.services and adv.complete_name == "Valve01":
                # print(adv)
                uart_connection = ble.connect(adv)
                uart_service = uart_connection[UARTService]
                print("Connected")
                break
        ble.stop_scan()
    try:
        if uart_connection and uart_connection.connected:
            # uart_service = uart_connection[UARTService]
            while uart_connection.connected:
                runningOperation = "startup"
                s = input("Valve directive: ")
                if s.strip() == "quit":
                    sys.exit()
                else:
                    uart_service.write(s.encode("utf-8"))
                    uart_service.write(b'\n')
                print("Running directive")
                startTime = datetime.datetime.now()
                cycleStart = startTime
                overallStart = startTime
                uart_service.reset_input_buffer()
                if uart_service.in_waiting == 0:
                    output = ""
                elif uart_service.in_waiting < 50:
                    output = ""
                    uart_service.reset_input_buffer()
                else:
                    output = uart_service.readline().decode("utf-8")
                    try:
                        ( drop1, drop2, operationCycle, drop4, operationValue) = output.split(",")
                        ( drop1, currentOperation) = operationValue.split("=")
                        ( drop1, currentCycleString) = operationCycle.split("=")
                        currentCycle = int(currentCycleString)
                    except ValueError:
                        currentOperation = runningOperation
                        currentCycle = cycle
                    if not currentOperation == runningOperation:
                        endTime = datetime.datetime.now()
                        print(runningOperation, "completed in", endTime-startTime, "seconds")
                        runningOperation = currentOperation
                        startTime = datetime.datetime.now()
                    if not cycle == currentCycle:
                        cycleStop = datetime.datetime.now()
                        print("cycle", cycle, "completed in", cycleStop - cycleStart, "seconds")
                        cycle = currentCycle
                        cycleStart = datetime.datetime.now()
                    if not currentOperation == runningOperation or not cycle == currentCycle:
                        print(output)
                while "done" not in output:
                    if uart_service.in_waiting == 0:
                        output = ""
                    elif uart_service.in_waiting < 50:
                        output = ""
                    else:
                        try:
                            output = uart_service.readline().decode("utf-8")
                            ( drop1 , drop2, operationCycle, drop4, operationValue ) = output.split(",")
                            ( drop1, currentOperation) = operationValue.split("=")
                            ( drop1, currentCycleString) = operationCycle.split("=")
                            currentCycle = int(currentCycleString)
                        except ValueError:
                            currentOperation = runningOperation
                            currentCycle = cycle
                        if not currentOperation == runningOperation:
                            endTime = datetime.datetime.now()
                            print(runningOperation, "completed in", endTime-startTime, "seconds")
                            print(output)
                            runningOperation = currentOperation
                            startTime = datetime.datetime.now()
                        if not cycle == currentCycle:
                            cycleStop = datetime.datetime.now()
                            print("cycle", cycle, "completed in", cycleStop - cycleStart, "seconds")
                            print(output)
                            cycle = currentCycle
                            cycleStart = datetime.datetime.now()
                        if currentOperation == "opening" or currentOperation == "closing":
                            print(output)
                print(output)
                overallStop = datetime.datetime.now()
                print("runcycle completed in", overallStop-overallStart, "seconds")
    except KeyboardInterrupt:
        if stop:
            sys.exit()
        else:
            stop = True